
subroutine ANVarGetReal(var, value, nvalue, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, intent(out):: value(*)
    integer, intent(in):: nvalue
    logical, intent(out):: err
    value(1: nvalue) = -999.0
    call StoreError(GT_EFAKE, "ANVarGetReal", err)
end subroutine

subroutine ANVarGetReal1(var, value, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    use netcdf_f77
    type(AN_VARIABLE), intent(inout):: var
    real, pointer:: value(:)
    logical, intent(out), optional:: err
    integer:: stat, ix, nx, ndims
    ndims = size(var%allcount)
    if (ndims < 1) then
        stat = NF_EINVALCOORDS
        goto 999
    endif
    !
    ! ͑Ώێ߂
    !
    do, ix = 1, ndims
        if (var%count(ix) > 1) exit
    enddo
    if (ix > ndims) ix = 1
    var%start(ix) = 1
    var%stride(ix) = 1
    nx = var%allcount(ix)
    var%count(ix) = nx
    !
    ! ͕ϐm
    !
    allocate(value(nx), stat=stat)
    if (stat /= 0) then
        stat = NF_ENOMEM
        goto 999
    endif
    !
    ! !
    !
    stat = nf_get_vars_real(var%fileid, var%varid, &
        start=var%start, count=var%count, stride=var%stride, &
        rvals=value)
999 continue
    call StoreError(stat, "ANVarGetReal1", err)
end subroutine

subroutine ANVarGetReal2(var, value, err)
    use an_types, only: AN_VARIABLE
    use netcdf_f77
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, pointer:: value(:, :)
    logical, intent(out), optional:: err
    integer:: stat, ix, iy, nx, ny, ndims
    ndims = size(var%allcount)
    if (ndims < 2) then
        call StoreError(NF_EINVALCOORDS, "ANVarGetReal2", err)
        return
    endif
    !
    ! ͑Ώێ߂
    !
    do, ix = 1, ndims
        if (var%count(ix) > 1) exit
    enddo
    if (ix > ndims) ix = 1
    do, iy = ix + 1, ndims
        if (var%count(ix) > 1) exit
    enddo
    if (iy > ndims) iy = ix + 1
    if (iy > ndims) then
        iy = ix
        ix = 1
        if (iy == ix) iy = 2
    endif
    var%start((/ix, iy/)) = 1
    var%stride((/ix, iy/)) = 1
    nx = var%allcount(ix);  var%count(ix) = nx
    ny = var%allcount(iy);  var%count(iy) = ny
    !
    ! ͕ϐm
    !
    allocate(value(nx, ny), stat=stat)
    if (stat /= 0) then
        call StoreError(NF_ENOMEM, "ANVarGetReal2", err)
        return
    endif
    !
    ! !
    !
    stat = nf_get_vars_real(var%fileid, var%varid, &
        start=var%start, count=var%count, stride=var%stride, &
        rvals=value)
    call StoreError(stat, "ANVarGetReal2", err)
end subroutine

subroutine ANVarGetReal3(var, value, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, pointer:: value(:, :, :)
    logical, intent(out), optional:: err
    if (associated(value)) value = -999.0
    call StoreError(GT_EFAKE, "ANVarGetReal3", err)
end subroutine



subroutine ANVarPutReal(var, value, nvalue, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, intent(in):: value(*)
    integer, intent(in):: nvalue
    logical, intent(out):: err
    call StoreError(GT_EFAKE, "ANVarPutReal", err)
end subroutine

subroutine ANVarPutReal1(var, value, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, intent(in):: value(:)
    logical, intent(out), optional:: err
    call StoreError(GT_EFAKE, "ANVarPutReal1", err)
end subroutine

subroutine ANVarPutReal2(var, value, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, intent(in):: value(:, :)
    logical, intent(out), optional:: err
    call StoreError(GT_EFAKE, "ANVarPutReal2", err)
end subroutine

subroutine ANVarPutReal3(var, value, err)
    use an_types, only: AN_VARIABLE
    use dc_error
    type(AN_VARIABLE), intent(inout):: var
    real, intent(in):: value(:, :, :)
    logical, intent(out), optional:: err
    call StoreError(GT_EFAKE, "ANVarPutReal3", err)
end subroutine